<?php
/**
 * Extra helpers.
 *
 * @since      1.4.3
 * @package    RevivePress
 * @subpackage RevivePress\Helpers\Premium
 * @author     Sayan Datta <iamsayan@protonmail.com>
 */

namespace RevivePress\Helpers\Premium;

defined( 'ABSPATH' ) || exit;

/**
 * Meta & Option class.
 */
trait Extras
{
	/**
	 * Build custom capabilities
	 *
	 * @return array
	 */
	protected function get_capabilities( $singular, $plural = null ) {
		if ( ! $plural ) {
			$plural = $singular . 's';
		}
		return array(
			'edit_post'              => "edit_$singular",
			'read_post'              => "read_$singular",
			'delete_post'            => "delete_$singular",
			'edit_posts'             => "edit_$plural",
			'edit_others_posts'      => "edit_others_$plural",
			'publish_posts'          => "publish_$plural",
			'read_private_posts'     => "read_private_$plural",
			'delete_posts'           => "delete_$plural",
			'delete_private_posts'   => "delete_private_$plural",
			'delete_published_posts' => "delete_published_$plural",
			'delete_others_posts'    => "delete_others_$plural",
			'edit_private_posts'     => "edit_private_$plural",
			'edit_published_posts'   => "edit_published_$plural",
			'create_posts'           => "edit_$plural",
		);
	}
}