<?php
/**
 * The Updates routine for version 1.3.2
 *
 * @since      1.3.2
 * @package    RevivePress
 * @subpackage RevivePress\Tools\updates
 * @author     Sayan Datta <iamsayan@protonmail.com>
 */

defined( 'ABSPATH' ) || exit;

/**
 * v1.3.2 migration
 */
function revivepress_1_3_2_migration() {
	as_unschedule_all_actions( 'wpar/global_republish_fetch_posts' ); // @phpstan-ignore-line

	if ( revivepress_fs()->can_use_premium_code__premium_only() ) {
		// gets the administrator role
		$role_object = get_role( 'administrator' );
		if ( is_null( $role_object ) || ! $role_object instanceof \WP_Role ) {
			return;
		}
		
		$role_object->add_cap( 'edit_republish_rule' );
		$role_object->add_cap( 'edit_republish_rules' );
		$role_object->add_cap( 'edit_others_republish_rules' );
		$role_object->add_cap( 'publish_republish_rules' );
		$role_object->add_cap( 'read_republish_rule' );
		$role_object->add_cap( 'read_private_republish_rules' );
		$role_object->add_cap( 'delete_republish_rule' );
		$role_object->add_cap( 'edit_published_republish_rules' );
	}

	$permalink_structure = get_option( 'permalink_structure' );
	$permalink_structure = str_replace( '%wpar_', '%rvp_', $permalink_structure );
	update_option( 'permalink_structure', $permalink_structure );

	flush_rewrite_rules();
}
revivepress_1_3_2_migration();